import rhinoscriptsyntax as rs
import Rhino.DocObjects

def loopBlock(block):
    objectsInBlock = rs.BlockObjects(rs.BlockInstanceName(block))

    for obj in objectsInBlock:
        if rs.ObjectType(obj) != 4096:
            action(obj)
        else:
            loopBlock(obj)

def action(object):
    rhino_object = rs.coercerhinoobject(object)
    rhino_object.Attributes.MaterialSource = Rhino.DocObjects.ObjectMaterialSource.MaterialFromLayer
    rhino_object.CommitChanges()

objs = rs.AllObjects(include_lights=False, include_grips=False)
if objs:
    for obj in objs:
        if rs.ObjectType(obj) == 4096: #block
           loopBlock(obj)
        else:
            action(obj)
else:
    print "No objects selectable."